/**
  ******************************************************************************
  * File Name          : main.h
  * Description        : This file contains the common defines of the application
  ******************************************************************************
  *
  * Copyright (c) 2017 STMicroelectronics International N.V. 
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without 
  * modification, are permitted, provided that the following conditions are met:
  *
  * 1. Redistribution of source code must retain the above copyright notice, 
  *    this list of conditions and the following disclaimer.
  * 2. Redistributions in binary form must reproduce the above copyright notice,
  *    this list of conditions and the following disclaimer in the documentation
  *    and/or other materials provided with the distribution.
  * 3. Neither the name of STMicroelectronics nor the names of other 
  *    contributors to this software may be used to endorse or promote products 
  *    derived from this software without specific written permission.
  * 4. This software, including modifications and/or derivative works of this 
  *    software, must execute solely and exclusively on microcontroller or
  *    microprocessor devices manufactured by or for STMicroelectronics.
  * 5. Redistribution and use of this software other than as permitted under 
  *    this license is void and will automatically terminate your rights under 
  *    this license. 
  *
  * THIS SOFTWARE IS PROVIDED BY STMICROELECTRONICS AND CONTRIBUTORS "AS IS" 
  * AND ANY EXPRESS, IMPLIED OR STATUTORY WARRANTIES, INCLUDING, BUT NOT 
  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
  * PARTICULAR PURPOSE AND NON-INFRINGEMENT OF THIRD PARTY INTELLECTUAL PROPERTY
  * RIGHTS ARE DISCLAIMED TO THE FULLEST EXTENT PERMITTED BY LAW. IN NO EVENT 
  * SHALL STMICROELECTRONICS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, 
  * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
  * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
  * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
  * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
  ******************************************************************************
  */
/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __MAIN_H
#define __MAIN_H
  /* Includes ------------------------------------------------------------------*/

/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* Private define ------------------------------------------------------------*/

#define Joystick_Up_Pin GPIO_PIN_2
#define Joystick_Up_GPIO_Port GPIOE
#define Joystick_Down_Pin GPIO_PIN_3
#define Joystick_Down_GPIO_Port GPIOE
#define Joystick_Left_Pin GPIO_PIN_4
#define Joystick_Left_GPIO_Port GPIOE
#define Joystick_Right_Pin GPIO_PIN_5
#define Joystick_Right_GPIO_Port GPIOE
#define Joystick_Fire_Pin GPIO_PIN_6
#define Joystick_Fire_GPIO_Port GPIOE
#define FMC_A0_Pin GPIO_PIN_0
#define FMC_A0_GPIO_Port GPIOF
#define FMC_A1_Pin GPIO_PIN_1
#define FMC_A1_GPIO_Port GPIOF
#define FMC_A2_Pin GPIO_PIN_2
#define FMC_A2_GPIO_Port GPIOF
#define FMC_A3_Pin GPIO_PIN_3
#define FMC_A3_GPIO_Port GPIOF
#define FMC_A4_Pin GPIO_PIN_4
#define FMC_A4_GPIO_Port GPIOF
#define FMC_A5_Pin GPIO_PIN_5
#define FMC_A5_GPIO_Port GPIOF
#define ILI9341_SPI5_CS_Pin GPIO_PIN_6
#define ILI9341_SPI5_CS_GPIO_Port GPIOF
#define ILI9341_SPI5_SCK_Pin GPIO_PIN_7
#define ILI9341_SPI5_SCK_GPIO_Port GPIOF
#define ILI9341_SPI5_MISO_Pin GPIO_PIN_8
#define ILI9341_SPI5_MISO_GPIO_Port GPIOF
#define ILI9341_SPI5_MOSI_Pin GPIO_PIN_9
#define ILI9341_SPI5_MOSI_GPIO_Port GPIOF
#define VGA_DE_Pin GPIO_PIN_10
#define VGA_DE_GPIO_Port GPIOF
#define HF__Pin GPIO_PIN_0
#define HF__GPIO_Port GPIOH
#define HF_H1_Pin GPIO_PIN_1
#define HF_H1_GPIO_Port GPIOH
#define FMC_SDNWE_Pin GPIO_PIN_0
#define FMC_SDNWE_GPIO_Port GPIOC
#define MEMS_SPI_SW_CS_Pin GPIO_PIN_1
#define MEMS_SPI_SW_CS_GPIO_Port GPIOC
#define ILI9341_SW_CS_Pin GPIO_PIN_2
#define ILI9341_SW_CS_GPIO_Port GPIOC
#define Joy1_PC_X_Pin GPIO_PIN_3
#define Joy1_PC_X_GPIO_Port GPIOC
#define Joy1_PC_Fire1_Pin GPIO_PIN_1
#define Joy1_PC_Fire1_GPIO_Port GPIOA
#define Joy1_PC_Fire2_Pin GPIO_PIN_2
#define Joy1_PC_Fire2_GPIO_Port GPIOA
#define VGA_B5_Pin GPIO_PIN_3
#define VGA_B5_GPIO_Port GPIOA
#define VGA_VSYNC_Pin GPIO_PIN_4
#define VGA_VSYNC_GPIO_Port GPIOA
#define VGA_G2_Pin GPIO_PIN_6
#define VGA_G2_GPIO_Port GPIOA
#define ILI9341_Reset_Pin GPIO_PIN_7
#define ILI9341_Reset_GPIO_Port GPIOA
#define Joy1_PC_Y_Pin GPIO_PIN_4
#define Joy1_PC_Y_GPIO_Port GPIOC
#define VGA_R3_Pin GPIO_PIN_0
#define VGA_R3_GPIO_Port GPIOB
#define VGA_R6_Pin GPIO_PIN_1
#define VGA_R6_GPIO_Port GPIOB
#define FMC_SDRAS_Pin GPIO_PIN_11
#define FMC_SDRAS_GPIO_Port GPIOF
#define FMC_A6_Pin GPIO_PIN_12
#define FMC_A6_GPIO_Port GPIOF
#define FMC_A7_Pin GPIO_PIN_13
#define FMC_A7_GPIO_Port GPIOF
#define FMC_A8_Pin GPIO_PIN_14
#define FMC_A8_GPIO_Port GPIOF
#define FMC_A9_Pin GPIO_PIN_15
#define FMC_A9_GPIO_Port GPIOF
#define FMC_A10_Pin GPIO_PIN_0
#define FMC_A10_GPIO_Port GPIOG
#define FMC_A11_Pin GPIO_PIN_1
#define FMC_A11_GPIO_Port GPIOG
#define FMC_D4_Pin GPIO_PIN_7
#define FMC_D4_GPIO_Port GPIOE
#define FMC_D5_Pin GPIO_PIN_8
#define FMC_D5_GPIO_Port GPIOE
#define FMC_D6_Pin GPIO_PIN_9
#define FMC_D6_GPIO_Port GPIOE
#define FMC_D7_Pin GPIO_PIN_10
#define FMC_D7_GPIO_Port GPIOE
#define FMC_D8_Pin GPIO_PIN_11
#define FMC_D8_GPIO_Port GPIOE
#define FMC_D9_Pin GPIO_PIN_12
#define FMC_D9_GPIO_Port GPIOE
#define FMC_D10_Pin GPIO_PIN_13
#define FMC_D10_GPIO_Port GPIOE
#define FMC_D11_Pin GPIO_PIN_14
#define FMC_D11_GPIO_Port GPIOE
#define FMC_D12_Pin GPIO_PIN_15
#define FMC_D12_GPIO_Port GPIOE
#define VGA_G4_Pin GPIO_PIN_10
#define VGA_G4_GPIO_Port GPIOB
#define VGA_G5_Pin GPIO_PIN_11
#define VGA_G5_GPIO_Port GPIOB
#define FMC_D13_Pin GPIO_PIN_8
#define FMC_D13_GPIO_Port GPIOD
#define FMC_D14_Pin GPIO_PIN_9
#define FMC_D14_GPIO_Port GPIOD
#define FMC_D15_Pin GPIO_PIN_10
#define FMC_D15_GPIO_Port GPIOD
#define ILI9341_RDX_Pin GPIO_PIN_12
#define ILI9341_RDX_GPIO_Port GPIOD
#define ILI9341_DC_Pin GPIO_PIN_13
#define ILI9341_DC_GPIO_Port GPIOD
#define FMC_D0_Pin GPIO_PIN_14
#define FMC_D0_GPIO_Port GPIOD
#define FMC_D1_Pin GPIO_PIN_15
#define FMC_D1_GPIO_Port GPIOD
#define FMC_BA0_Pin GPIO_PIN_4
#define FMC_BA0_GPIO_Port GPIOG
#define FMC_BA1_Pin GPIO_PIN_5
#define FMC_BA1_GPIO_Port GPIOG
#define VGA_R7_Pin GPIO_PIN_6
#define VGA_R7_GPIO_Port GPIOG
#define VGA_CLK_Pin GPIO_PIN_7
#define VGA_CLK_GPIO_Port GPIOG
#define FMC_SDCLK_Pin GPIO_PIN_8
#define FMC_SDCLK_GPIO_Port GPIOG
#define VGA_HSYNC_Pin GPIO_PIN_6
#define VGA_HSYNC_GPIO_Port GPIOC
#define VGA_G6_Pin GPIO_PIN_7
#define VGA_G6_GPIO_Port GPIOC
#define SDcard_D0_Pin GPIO_PIN_8
#define SDcard_D0_GPIO_Port GPIOC
#define SDcard_D1_Pin GPIO_PIN_9
#define SDcard_D1_GPIO_Port GPIOC
#define VGA_R4_Pin GPIO_PIN_11
#define VGA_R4_GPIO_Port GPIOA
#define VGA_R5_Pin GPIO_PIN_12
#define VGA_R5_GPIO_Port GPIOA
#define DBG_SWDIO_Pin GPIO_PIN_13
#define DBG_SWDIO_GPIO_Port GPIOA
#define DBG_SWCLK_Pin GPIO_PIN_14
#define DBG_SWCLK_GPIO_Port GPIOA
#define SDcard_D2_Pin GPIO_PIN_10
#define SDcard_D2_GPIO_Port GPIOC
#define SDcard_D3_Pin GPIO_PIN_11
#define SDcard_D3_GPIO_Port GPIOC
#define SDcard_CLK_Pin GPIO_PIN_12
#define SDcard_CLK_GPIO_Port GPIOC
#define FMC_D2_Pin GPIO_PIN_0
#define FMC_D2_GPIO_Port GPIOD
#define FMC_D3_Pin GPIO_PIN_1
#define FMC_D3_GPIO_Port GPIOD
#define SDcard_CMD_Pin GPIO_PIN_2
#define SDcard_CMD_GPIO_Port GPIOD
#define VGA_G7_Pin GPIO_PIN_3
#define VGA_G7_GPIO_Port GPIOD
#define SDcard_Detect_Pin GPIO_PIN_5
#define SDcard_Detect_GPIO_Port GPIOD
#define VGA_G3_Pin GPIO_PIN_10
#define VGA_G3_GPIO_Port GPIOG
#define VGA_B3_Pin GPIO_PIN_11
#define VGA_B3_GPIO_Port GPIOG
#define VGA_B4_Pin GPIO_PIN_12
#define VGA_B4_GPIO_Port GPIOG
#define LED_GREEN_Pin GPIO_PIN_13
#define LED_GREEN_GPIO_Port GPIOG
#define LED_RED_Pin GPIO_PIN_14
#define LED_RED_GPIO_Port GPIOG
#define FMC_SDCAS_Pin GPIO_PIN_15
#define FMC_SDCAS_GPIO_Port GPIOG
#define DBG_SWO_Pin GPIO_PIN_3
#define DBG_SWO_GPIO_Port GPIOB
#define FMC_SDCKE1_Pin GPIO_PIN_5
#define FMC_SDCKE1_GPIO_Port GPIOB
#define FMC_SDNE1_Pin GPIO_PIN_6
#define FMC_SDNE1_GPIO_Port GPIOB
#define VGA_B6_Pin GPIO_PIN_8
#define VGA_B6_GPIO_Port GPIOB
#define VGA_B7_Pin GPIO_PIN_9
#define VGA_B7_GPIO_Port GPIOB
#define FMC_NBL0_Pin GPIO_PIN_0
#define FMC_NBL0_GPIO_Port GPIOE
#define FMC_NBL1_Pin GPIO_PIN_1
#define FMC_NBL1_GPIO_Port GPIOE
/* USER CODE BEGIN Private defines */

/* USER CODE END Private defines */

/**
  * @}
  */ 

/**
  * @}
*/ 

#endif /* __MAIN_H */
/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
